package br.usp.ime.prolog.editor;

import br.usp.ime.prolog.PrologPlugin;
import org.eclipse.ui.editors.text.TextEditor;
import org.eclipse.jface.util.PropertyChangeEvent; 

/**
 * @author Juliana 
 * 
 * The Prolog Editor.
 */
public class PrologEditor extends TextEditor {
	TokenManager tokenManager;

	public PrologEditor() {
		super();		
		tokenManager = new TokenManager(PrologPlugin.getDefault().getPreferenceStore());
		setSourceViewerConfiguration(new PrologEditorViewerConfiguration(tokenManager));
		setDocumentProvider(new PrologDocumentProvider());
		setPreferenceStore(PrologPlugin.getDefault().getPreferenceStore());
	}
		
	protected boolean affectsTextPresentation(
	   PropertyChangeEvent event)
	{
	   return super.affectsTextPresentation(event)
		  || tokenManager.affectsTextPresentation(event);
	}


	protected void handlePreferenceStoreChanged(
	   PropertyChangeEvent event)
	{	
	   tokenManager.handlePreferenceStoreChanged(event);
	   super.handlePreferenceStoreChanged(event);
	}

	
	public void dispose() {
		super.dispose();
	}

}
