package br.usp.ime.prolog.editor;

import br.usp.ime.prolog.preferences.IPrologPreferenceFields;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.presentation.IPresentationReconciler;
import org.eclipse.jface.text.presentation.PresentationReconciler;
import org.eclipse.jface.text.rules.DefaultDamagerRepairer;
import org.eclipse.jface.text.source.ISourceViewer;
import org.eclipse.jface.text.source.SourceViewerConfiguration;


public class PrologEditorViewerConfiguration extends SourceViewerConfiguration {
	//private XMLDoubleClickStrategy doubleClickStrategy;
	private PrologRuleScanner scanner;
	private TokenManager tokenManager;


	public PrologEditorViewerConfiguration(TokenManager tokenManager) {
		this.tokenManager = tokenManager;
	}
	
	// TODO: Verificar a necessidade de uma 'DoubleClickStrategy'.
	/*
	public ITextDoubleClickStrategy getDoubleClickStrategy(
		ISourceViewer sourceViewer,
		String contentType) {
		if (doubleClickStrategy == null)
			doubleClickStrategy = new XMLDoubleClickStrategy();
		return doubleClickStrategy;
	}
	*/

	protected PrologRuleScanner getPrologScanner() {
		if (scanner == null) {
			scanner = new PrologRuleScanner(tokenManager);
			scanner.setDefaultReturnToken(
				tokenManager.getToken(IPrologPreferenceFields.PREF_DEFAULT_COLOR));
		}
		return scanner;
	}

	public IPresentationReconciler getPresentationReconciler(ISourceViewer sourceViewer) {
		PresentationReconciler reconciler = new PresentationReconciler();

		DefaultDamagerRepairer dr = new DefaultDamagerRepairer(getPrologScanner());
		reconciler.setDamager(dr, IDocument.DEFAULT_CONTENT_TYPE);
		reconciler.setRepairer(dr, IDocument.DEFAULT_CONTENT_TYPE);
		return reconciler;
	}

}