package br.usp.ime.prolog.preferences;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.layout.GridData;
import br.usp.ime.prolog.PrologPlugin;
import org.eclipse.jface.preference.*;
import org.eclipse.ui.*;

/**
 * 
 * @author Juliana
 *
 * The Prolog Prefences Page. 
 * 
 */
public class PrologPreferencePage extends FieldEditorPreferencePage
                                  implements IWorkbenchPreferencePage
{

   public PrologPreferencePage()
   {
      super(GRID);
      setPreferenceStore(
         PrologPlugin.getDefault().getPreferenceStore());
      //setDescription("Prolog editor settings:");	  
   }
   
   public void createFieldEditors()
   {   		   	

	Group g = new Group(getFieldEditorParent(),SWT.SHADOW_ETCHED_IN);
	GridData gd = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
	gd.horizontalSpan = 3;
	g.setLayoutData(gd);
	g.setText("Prolog editor settings:");

	Label l1= new Label(g, SWT.LEFT);
	l1.setText("");
	gd = new GridData();
	gd.horizontalSpan = 3;
	l1.setLayoutData(gd);

 	addField(
		new ColorFieldEditor(
			IPrologPreferenceFields.PREF_COMMENT_COLOR,
			"    &Comments:",
			g)) ;
	addField(
		new ColorFieldEditor(
			IPrologPreferenceFields.PREF_BUILTIN_COLOR,
			"    &Built-in Predicates:",
			g));
	addField(
		new ColorFieldEditor(
			IPrologPreferenceFields.PREF_VAR_COLOR,
			"    &Variables:",
			g));			
	addField(
		new ColorFieldEditor(
			IPrologPreferenceFields.PREF_OPER_COLOR,
			"    &Operators:",
			g));
	addField(
		new ColorFieldEditor(
			IPrologPreferenceFields.PREF_STRING_COLOR,
			"    &Strings:",
			g));			
	addField(
		new ColorFieldEditor(
			IPrologPreferenceFields.PREF_DEFAULT_COLOR,
			"    O&thers:",
			g));			

	Label l2= new Label(g, SWT.LEFT);
	l2.setText("");
	gd = new GridData();
	gd.horizontalSpan = 3;
	l2.setLayoutData(gd);

	Label l3= new Label(getFieldEditorParent(), SWT.LEFT);
	l3.setText("");
	gd = new GridData();
	gd.horizontalSpan = 3;
	l3.setLayoutData(gd);

	//DirectoryFieldEditor pathEditor =
	StringFieldEditor pathEditor =
		new StringFieldEditor(
			IPrologPreferenceFields.PREF_PROLOG_PATH,
			"&Prolog interpreter path: ",
			getFieldEditorParent());
	pathEditor.setEmptyStringAllowed(false);
	addField(pathEditor);
		
   }

   public void init(IWorkbench workbench)
   {
   }

}